#include "Lexer.h"

std::string IdentifierStr; // Filled when token == tok_identifier
double NumVal;             // Filled when token == tok_number
int gettok(FILE *fp){
    static int lastChar = ' ';

    while(isspace(lastChar))
        lastChar = fgetc(fp);
    
    if(isalpha(lastChar)){
        IdentifierStr = lastChar;
        while(isalnum(lastChar = fgetc(fp)))
            IdentifierStr += lastChar;

        if(IdentifierStr == "def")
            return tok_def;
        if(IdentifierStr == "extern")
            return tok_extern;
        return tok_identifier;
    }

    if(isdigit(lastChar)){
        std::string numStr;
        bool dotAppeared = false;
        bool numErr = false;
        do {
            numStr += lastChar;
            lastChar = fgetc(fp);
            if(lastChar == '.'){
                if(dotAppeared)
                    numErr = true;
                else
                    dotAppeared = true;
            }
        } while(isdigit(lastChar) || lastChar == '.');

        if(numErr){
            printf("%s is not a number\n", numStr.c_str());
            exit(1);
        }
        NumVal = strtod(numStr.c_str(), 0);
        return tok_number;
    }

    if(lastChar == '#'){
        do lastChar = fgetc(fp);
        while(lastChar != EOF && lastChar != '\n' && lastChar != 'r');

        if(lastChar != EOF)
            return gettok(fp);
    }

    if(lastChar == EOF)
        return tok_eof;

    int thisChar = lastChar;
    lastChar = fgetc(fp);
    return thisChar;
}
